package cn.iocoder.yudao.module.iot.service.frpc;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.mock.mockito.MockBean;


import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.iot.controller.admin.frpc.vo.*;
import cn.iocoder.yudao.module.iot.dal.dataobject.frpc.FrpcProxyServerDO;
import cn.iocoder.yudao.module.iot.dal.mysql.frpc.FrpcProxyServerMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;


import org.springframework.context.annotation.Import;

import javax.annotation.Resource;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.iot.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link FrpcProxyServerServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(FrpcProxyServerServiceImpl.class)
public class FrpcProxyServerServiceImplTest extends BaseDbUnitTest {

    @Resource
    private FrpcProxyServerServiceImpl frpcProxyServerService;

    @Resource
    private FrpcProxyServerMapper frpcProxyServerMapper;

    @Test
    public void testCreateFrpcProxyServer_success() {
        // 准备参数
        FrpcProxyServerSaveReqVO createReqVO = randomPojo(FrpcProxyServerSaveReqVO.class).setId(null);

        // 调用
        Long frpcProxyServerId = frpcProxyServerService.createFrpcProxyServer(createReqVO);
        // 断言
        assertNotNull(frpcProxyServerId);
        // 校验记录的属性是否正确
        FrpcProxyServerDO frpcProxyServer = frpcProxyServerMapper.selectById(frpcProxyServerId);
        assertPojoEquals(createReqVO, frpcProxyServer, "id");
    }

    @Test
    public void testUpdateFrpcProxyServer_success() {
        // mock 数据
        FrpcProxyServerDO dbFrpcProxyServer = randomPojo(FrpcProxyServerDO.class);
        frpcProxyServerMapper.insert(dbFrpcProxyServer);// @Sql: 先插入出一条存在的数据
        // 准备参数
        FrpcProxyServerSaveReqVO updateReqVO = randomPojo(FrpcProxyServerSaveReqVO.class, o -> {
            o.setId(dbFrpcProxyServer.getId()); // 设置更新的 ID
        });

        // 调用
        frpcProxyServerService.updateFrpcProxyServer(updateReqVO);
        // 校验是否更新正确
        FrpcProxyServerDO frpcProxyServer = frpcProxyServerMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, frpcProxyServer);
    }

    @Test
    public void testUpdateFrpcProxyServer_notExists() {
        // 准备参数
        FrpcProxyServerSaveReqVO updateReqVO = randomPojo(FrpcProxyServerSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> frpcProxyServerService.updateFrpcProxyServer(updateReqVO), FRPC_PROXY_SERVER_NOT_EXISTS);
    }

    @Test
    public void testDeleteFrpcProxyServer_success() {
        // mock 数据
        FrpcProxyServerDO dbFrpcProxyServer = randomPojo(FrpcProxyServerDO.class);
        frpcProxyServerMapper.insert(dbFrpcProxyServer);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbFrpcProxyServer.getId();

        // 调用
        frpcProxyServerService.deleteFrpcProxyServer(id);
       // 校验数据不存在了
       assertNull(frpcProxyServerMapper.selectById(id));
    }

    @Test
    public void testDeleteFrpcProxyServer_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> frpcProxyServerService.deleteFrpcProxyServer(id), FRPC_PROXY_SERVER_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetFrpcProxyServerPage() {
       // mock 数据
       FrpcProxyServerDO dbFrpcProxyServer = randomPojo(FrpcProxyServerDO.class, o -> { // 等会查询到
           o.setFrpcName(null);
           o.setLocalIp(null);
           o.setLocalPort(null);
           o.setSuffixPath(null);
           o.setLocalStatus(null);
           o.setFrpsId(null);
           o.setProxyPort(null);
           o.setProxyAddress(null);
           o.setProxyStatus(null);
           o.setRemark(null);
           o.setIsEnable(null);
           o.setCreateTime(null);
       });
       frpcProxyServerMapper.insert(dbFrpcProxyServer);
       // 测试 frpcName 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setFrpcName(null)));
       // 测试 localIp 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setLocalIp(null)));
       // 测试 localPort 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setLocalPort(null)));
       // 测试 suffixPath 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setSuffixPath(null)));
       // 测试 localStatus 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setLocalStatus(null)));
       // 测试 frpsId 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setFrpsId(null)));
       // 测试 proxyPort 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setProxyPort(null)));
       // 测试 proxyAddress 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setProxyAddress(null)));
       // 测试 proxyStatus 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setProxyStatus(null)));
       // 测试 remark 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setRemark(null)));
       // 测试 isEnable 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setIsEnable(null)));
       // 测试 createTime 不匹配
       frpcProxyServerMapper.insert(cloneIgnoreId(dbFrpcProxyServer, o -> o.setCreateTime(null)));
       // 准备参数
       FrpcProxyServerPageReqVO reqVO = new FrpcProxyServerPageReqVO();
       reqVO.setFrpcName(null);
       reqVO.setLocalIp(null);
       reqVO.setLocalPort(null);
       reqVO.setSuffixPath(null);
       reqVO.setLocalStatus(null);
       reqVO.setFrpsId(null);
       reqVO.setProxyPort(null);
       reqVO.setProxyAddress(null);
       reqVO.setProxyStatus(null);
       reqVO.setRemark(null);
       reqVO.setIsEnable(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<FrpcProxyServerDO> pageResult = frpcProxyServerService.getFrpcProxyServerPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbFrpcProxyServer, pageResult.getList().get(0));
    }

}